package game;
/**
 *
 * @author Vandole
 */
                                                                     
                                                                     
                                                                     
                                             
/*
 * This code is protected under the Gnu General Public License (Copyleft), 2005 by
 * IBM and the Computer Science Teachers Association. It may be freely
 * modified and redistributed under educational fair use.
 */

import java.awt.Color;

//import csta.ibm.pong.Game;

import java.util.Random;

import javax.swing.*;

import java.awt.event.*;

public class Pong extends Game {
	// Add any state variables or object references here
	/**Sentinel value for the winning score of the game, when one
	 * of the players reaches this score, the <code>p1Wins()</code>
	 * or the <code>p2Wins()</code> dialog window will trigger, notifying
	 * each player of the winner*/
		public static final int WINNING_SCORE = 10;
	  
		Paddle top = new Paddle();
		Paddle bottom = new Paddle();
		Ball ball = new Ball();
		Random rand = new Random();
		JLabel p1Score = new JLabel("Uno");
		JLabel p2Score = new JLabel("Dos");
		JLabel p1 = new JLabel();
		JLabel p2 = new JLabel();
		int p1S = 0;
		int p2S = 0;
		
		int ball_Speed = Ball.speed;
		static double speed_Mult = 0;
		
		int pad_Length = top.getWidth();
		static double pad_Exten = 0;
		
		JMenu game = new JMenu("Game");
		JMenu info = new JMenu("Info");
		
		JMenuItem speed = new JMenuItem("Speed Multiplier: " + speed_Mult + "%");
		JMenuItem pad = new JMenuItem("Paddle Length Multiplier: " + pad_Exten + "%");
		
		JMenuItem restart = new JMenuItem("RESTART");
		JMenuItem pause = new JMenuItem("PAUSE");
		JMenuItem resume = new JMenuItem("RESUME");
		JMenuItem speedUp = new JMenuItem("INCREASE SPEED");
		JMenuItem slowDown = new JMenuItem("DECREASE SPEED");
		JMenuItem widthUp = new JMenuItem("MAKE DEM PADDLES BIGGA");
		JMenuItem widthDown = new JMenuItem("MAKE DEM PADDLES SMALLA");
		
	/**
	 * Fill in this method with code that tells the game what to do
	 * before actual play begins
	 */
	public void setup() {
		
	//	setSize(1000, 500);
		
		top.setSize(200,20);
		bottom.setSize(200,20);
		ball.setSize(10,10);
		
		ball.setXVelocity(Ball.speed);
		ball.setYVelocity(Ball.speed);
		
		top.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
		
		bottom.setX((getFieldWidth() / 2) - (bottom.getWidth() / 2));
		bottom.setY(getFieldHeight() - bottom.getHeight());
		
		ball.setX((getFieldWidth() / 2) - (ball.getX() / 2));
		ball.setY((getFieldHeight() / 2)  - (ball.getY() / 2));
		
		top.setColor(Color.PINK);
		bottom.setColor(Color.PINK);
		ball.setColor(Color.MAGENTA);
              		
		p1Score.setSize(50,30);
		p2Score.setSize(50,30);
		p1Score.setLocation(getFieldWidth() - getFieldWidth(), getFieldHeight() - getFieldHeight());
		p2Score.setLocation(getFieldWidth() - p2Score.getWidth(), getFieldHeight() - getFieldHeight());
		p1Score.setHorizontalTextPosition(SwingConstants.CENTER);
		p1Score.setVerticalTextPosition(SwingConstants.CENTER);
		
		p2Score.setHorizontalTextPosition(SwingConstants.CENTER);
		p2Score.setVerticalTextPosition(SwingConstants.CENTER);
		
		p1.setSize(80, 50);
		p2.setSize(80, 50);
		
		p1.setLocation(getFieldWidth() - getFieldWidth(), (getFieldHeight() - getFieldHeight()) + top.getHeight());
		p2.setLocation(getFieldWidth() - p2.getWidth(), (getFieldHeight() - getFieldHeight()) + top.getHeight());
		
		
		getJMenuBar().add(game);
                game.add(restart);
		game.add(pause);
		game.add(resume);
		game.add(speedUp);
		game.add(slowDown);
		game.add(widthUp);
		game.add(widthDown);
		//getJMenuBar().add(info);
		
		
		
		info.add(speed);
		info.add(pad);
		
		restart.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				restart();
			}
		});
		pause.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				stopGame();
			}
		});
		resume.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				startGame();
			}
		});
		speedUp.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/*
				 * Increase the movement speed of the ball and the
				 * paddles by the same increment, capping them at a 
				 * maximum of 5*/
				Ball.speed += 1;
				Paddle.speed += 1;
				
				if(Ball.speed > 5){
					Ball.speed = 5;
				};
				if(Paddle.speed > 5){
					Paddle.speed = 5;
				};
				ball.setXVelocity(Ball.speed);
				ball.setYVelocity(Ball.speed);
				
				/*The percentage by which the game as a whole has been sped up.
				 * Using Ball.BALL_SPEED was my choice, Paddle.PADDLE_SPEED could have been
				 * used as well.*/
				speed_Mult = (speed_Mult + (ball_Speed / Ball.speed));
			};
		});
		slowDown.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				Ball.speed -= 1;
				Paddle.speed -= 1;
				
				if(Ball.speed < 1){
					Ball.speed = 1;
				};
				if(Paddle.speed < 1){
					Paddle.speed = 1;
				};
				
				ball.setXVelocity(Ball.speed);
				ball.setYVelocity(Ball.speed);
				speed_Mult = (speed_Mult - (ball_Speed / Ball.speed));
			};
		});
		widthUp.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				//Each Paddle is increased by the same amount
				top.setSize(top.getWidth() + 20, top.getHeight());
				bottom.setSize(bottom.getWidth() + 20, bottom.getHeight());
				top.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
				bottom.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
				
				//Percentage by which each paddle is extended
				pad_Exten = (pad_Exten + (pad_Length / top.getWidth()));
			};
		});
		widthDown.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				top.setSize(top.getWidth() - 20, top.getHeight());
				bottom.setSize(bottom.getWidth() - 20, bottom.getHeight());
				top.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
				bottom.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
				
				pad_Exten = (pad_Exten + (pad_Length / top.getWidth()));
			};
		});
		
		add(top);
		add(bottom);
		add(ball);
		
		add(p1Score);
		add(p2Score);
		
		add(p1);
		add(p2);
		
		setDelay(10);
                
	}
	
	/**
	 * Fill in this method with code that tells the playing field what to do
	 * from one moment to the next
	 */
	public void act() {
		press();
		//release();
		collisions();
		scorekeeper();
	}
	
	// Add any additional methods here
	/**Handles all effects triggered by key press events*/
	public void press(){
		if(ZKeyPressed()){
			top.setXVelocity(Paddle.speed * -1);
		}
		
		if(XKeyPressed()){
			top.setXVelocity(Paddle.speed);
		}
		
		if(NKeyPressed()){
			bottom.setXVelocity(Paddle.speed * -1);
		}
		
		if(MKeyPressed()){
			bottom.setXVelocity(Paddle.speed);
		}
	}
	
	/**Handles all effects triggered by key releases*/
	public void release(){
		if(!ZKeyPressed() && !XKeyPressed()){
			top.setXVelocity(0);
		}
		
		if(!NKeyPressed() && !MKeyPressed()){
			bottom.setXVelocity(0);
		}
	}
	
	/**Handle all entity collision events in the game*/
	public void collisions(){
		//Paddle to window collision
		//If top paddle comes in contact with top edge
		if(top.getX() <= 0){
			top.setX(top.getX() + 1);	
			top.setXVelocity(0);
		}
		//If top paddle comes in contact with bottom edge
		if((top.getX() + top.getWidth()) >= getFieldWidth()){
			top.setX(top.getX() - 1);
			top.setXVelocity(0);
		}
		//If bottom paddle comes in contact with top edge
		if(bottom.getX() <= 0){
			bottom.setX(bottom.getX() + 1);
			bottom.setXVelocity(0);
		}
		//If bottom paddle comes in contact with bottom edge
		if((bottom.getX() + bottom.getWidth()) >= getFieldWidth()){
			bottom.setX(bottom.getX() - 1);
			bottom.setXVelocity(0);
		}
		//Ball to paddle collision
		if(ball.collides(top) || ball.collides(bottom)){
		//	ball.setXVelocity(ball.getXVelocity() * -1);
			ball.setYVelocity(ball.getYVelocity() * -1);
		}
		//Ball to window collision
		if(ball.getX() <= 0 || (ball.getX() + ball.getWidth()) > getFieldWidth()){
			ball.setXVelocity(ball.getXVelocity() * -1);
		//	ball.setYVelocity(ball.getYVelocity() * -1);
		}
	}
	
	public void scorekeeper(){
		//If Ball gets past one of the Paddles
				if((ball.getY() + ball.getHeight()) > getFieldHeight()){
				//Player 2 Scores
					reset();
					p2S ++;
						if(p2S == WINNING_SCORE){
							stopGame();
							p2Wins();
                                                        
						};
				};
				if(ball.getY() <= 0){
				//Player 1 Scores
					reset();
					p1S ++;
						if(p1S == WINNING_SCORE){
							stopGame();
							p1Wins();
                                                        
						};
				};
		//Keep each player's score update
		p1.setText(Integer.toString(p1S));
		p2.setText(Integer.toString(p2S));
		/*
		//Keep the Info Fields updated
		speed.setText("Speed Multiplier: " + speed_Mult + "%");
		pad.setText("Paddle Length Multiplier: " + pad_Exten + "%");*/
	};
	/**Reset the ball and the paddles in preparation for a new round*/
	public void reset(){
		top.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
		top.setY(0);
		
		bottom.setX((getFieldWidth() / 2) - (bottom.getWidth() / 2));
		bottom.setY(getFieldHeight() - bottom.getHeight());
		
		int x = Ball.speed;
		int y = Ball.speed;
		rand.setSeed(System.currentTimeMillis());
		
                if ((rand.nextInt() % 2) == 0 )
                {
                   x = Ball.speed; 
                }
                
                else
                {
                    x = Ball.speed *-1;
                }
               
                
                 if ((rand.nextInt() % 2) == 0 )
                {
                   y = Ball.speed; 
                }
                
                else
                {
                    y = Ball.speed * -1;
                }	
		
		ball.setX((getFieldWidth() / 2) - (ball.getWidth() / 2));
		ball.setY((getFieldHeight() / 2) - (ball.getHeight() / 2));
		
		ball.setXVelocity(x);
		ball.setYVelocity(y);
	};
	/**Reset each variable to prepare for a new game*/
	public void restart(){
		Ball.speed = 4;
		Paddle.speed = 6;
		p1S = 0;
		p2S = 0;
		reset();
		startGame();
                
	};
	/**
	 * This code has been provided for you, and should not be modified
	 */
	public static void main(String[] args) {
		Pong p = new Pong();
		p.setVisible(true);
		p.initComponents();
               
	}
}